<?php

/**
 *
 * @copyright  2010 frasq.org
 * @version    1
 * @link       http://www.frasq.org
 */

require_once 'unsetglobals.php';
require_once 'validatehostname.php';

function bootstrap() {
	global $base_url, $base_path, $base_root;

	if (isset($_SERVER['HTTP_HOST'])) {
		$_SERVER['HTTP_HOST'] = strtolower($_SERVER['HTTP_HOST']);
		if (!validate_host_name($_SERVER['HTTP_HOST'])) {
			header('HTTP/1.1 400 Bad Request');
			exit;
		}
	}
	else {
		$_SERVER['HTTP_HOST'] = '';
	}

	unset_globals();
	
	@include 'settings.inc';
	@include 'config.inc';

	if (isset($base_url)) {
		$base_url = trim($base_url, '/');

		$url = parse_url($base_url);

		if (!isset($url['path'])) {
			$url['path'] = '';
		}

		$base_path = $url['path'];
		$base_root = substr($base_url, 0, strlen($base_url) - strlen($base_path));
	}
	else {
		$base_root = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https' : 'http';

		$base_url = $base_root .= '://'. $_SERVER['HTTP_HOST'];

		if ($dir = trim(dirname($_SERVER['SCRIPT_NAME']), '\,/')) {
			$base_path = '/' . $dir;
			$base_url .= $base_path;
		}
		else {
			$base_path = '';
		}
	}
}

